IncludeScript("matm_RolesController.nut")
liveplycount 			<- null
::PlayerManager <- Entities.FindByClassname(null, "tf_player_manager");
::GetPlayerUserID <- function(player){
    return NetProps.GetPropIntArray(PlayerManager, "m_iUserID", player.entindex());
}
ClearGameEventCallbacks()

const RETHINK_TIME = 1
function worldwatch() {//printl("world watch running")
    liveplycount = 0
	local playersalive = null
	while(playersalive = Entities.FindByClassname(playersalive, "player")){
		local lifestate = NetProps.GetPropInt(playersalive, "m_lifeState")
		if (lifestate == 0) {
			if (liveplycount == null) {
				liveplycount = 1
			}
			else{
			    liveplycount = liveplycount += 1
			}
		}
	}

	local roundwin = Entities.FindByName(null, "game_round_win_blu")
    if (liveplycount <= 1 && roundstate == "midround") {
		local roundend = SpawnEntityFromTable("game_round_win", {
                TeamNum         = 3, // 2 for red, 3 for blue, 0 for none
                switch_teams    = 0,
                force_map_reset = 1,
        })
		if (murderer != null) {murderer.ForceChangeTeam(3, true)}
		if (Convars.GetInt("tf_gravetalk") 		 != 1) {Convars.SetValue("tf_gravetalk", 1)}
		if (Convars.GetInt("mp_respawnwavetime") != 1) {Convars.SetValue("mp_respawnwavetime", 1)}
		EntFireByHandle(roundend, "RoundWin", "", 0, roundend, roundend); EntFireByHandle(roundend, "Kill", "", 10, roundend, roundend)
        roundstate = "preround"
	}
    return RETHINK_TIME
}

function OnGameEvent_player_death(params){
	if (murderer != null) {
		if(params.userid == GetPlayerUserID(murderer)) {
			local roundend = SpawnEntityFromTable("game_round_win", {
    	            TeamNum         = 2, // 2 for red, 3 for blue, 1 for spec
    	            switch_teams    = 0,
    	            force_map_reset = 1,
    	    })
			murderer.ForceChangeTeam(3, true)
			if (Convars.GetInt("tf_gravetalk") 		 != 1) {Convars.SetValue("tf_gravetalk", 1)}
			if (Convars.GetInt("mp_respawnwavetime") != 1) {Convars.SetValue("mp_respawnwavetime", 1)}
			EntFireByHandle(roundend, "RoundWin", "", 0, roundend, roundend); EntFireByHandle(roundend, "Kill", "", 10, roundend, roundend)
    	    roundstate = "preround"
		}
	}
}

function TimeRanOut() {
	local roundend = SpawnEntityFromTable("game_round_win", {
            TeamNum         = 0, // 2 for red, 3 for blue, 0 for none, 1 ?
            switch_teams    = 0,
            force_map_reset = 1,
    })
	murderer.ForceChangeTeam(3, true)
	if (Convars.GetInt("tf_gravetalk") 		 != 1) {Convars.SetValue("tf_gravetalk", 1)}
	if (Convars.GetInt("mp_respawnwavetime") != 1) {Convars.SetValue("mp_respawnwavetime", 1)}
	EntFireByHandle(roundend, "RoundWin", "", 0, roundend, roundend); EntFireByHandle(roundend, "Kill", "", 10, roundend, roundend)
    roundstate = "preround"
	
}

__CollectGameEventCallbacks(this)